package org.jythonx.bzip2;


public class ShortView{
    byte[] b;
    int start;
    ShortView(byte[] b){ this.b = b; }

    public short get(int i){
        i *=2;
        return (short)((b[i] & 0xff) <<8|(b[i+1] & 0xff));
    }


    public int getUInt16(int i){
        i *=2;
        return (((b[i] & 0xff) << 8) | (b[i+1] & 0xff));
    }

    public void put(int i, short j){
        i *=2;
        b[i] = (byte)(j >> 8);
        b[i+1] = (byte)(j);
    }

    public int capacity(){ return b.length/2; }

    public boolean ui_gt(int i1, int i2){
        i1 *= 2; i2 *= 2;
        return (((b[i1] & 0xff) << 8) | (b[i1+1] & 0xff)) >
               (((b[i2] & 0xff) << 8) | (b[i2+1] & 0xff));

    }

    public int cmp(int i1, int i2){
        int s1 = getUInt16(i1);
        int s2 = getUInt16(i2);
        if(s1 != s2) return s1 > s2? 1: 2;
        return 0;
    }

}