package org.jythonx.bzip2;


public class ShortViewSlice extends ShortView{
    ShortViewSlice(byte[] b, int start){ super(b); this.start = start; }

    public short get(int i){
        i = (i*2) + start;
        return (short)(b[i]<<8|(b[i+1] & 0xff));
    }

    public int getUInt16(int i){
        i = (i*2) + start;
        return (((b[i] & 0xff) << 8) | (b[i+1] & 0xff));
    }

    public void put(int i, short j){
        i = (i*2) + start;
        b[i] = (byte)(j >> 8);
        b[i+1] = (byte)(j);
    }

    public boolean ui_gt(int i1, int i2){
        i1 = (i1*2) + start; i2 = (i2 *2) + start;
        return (((b[i1] & 0xff) << 8) | (b[i1+1] & 0xff)) >
               (((b[i2] & 0xff) << 8) | (b[i2+1] & 0xff));

    }



    public int capacity(){ return (b.length-start)/2; }
}