package org.jythonx.bzip2;


public class blocksort implements BZConstants{

    public static void fallbackSort ( /** UInt32 */ IntView fmap,  
                                      /** UInt32 */ IntView eclass, 
                                     /** UInt32 */ IntView bhtab,
                                     int nblock,
                                     int verb ){
        int ftab[] = new int[257];
        //int ftabCopy[] = new int[256];
        int H, i, j, k, l, r, cc, cc1;
        int nNotDone;
        int nBhtab;
        //UChar* eclass8 = (UChar*)eclass;
        byte[] eclass8 = eclass.b;//_eclass;//
        //byte[] eclass8_2 = eclass8.clone();
        //does work of ftabCopy
        eclass.snapshot();

        /**--
          Initial 1-char radix sort to generate
          initial fmap and initial BH bits.
        --*/
        //if (verb >= 4)
        // VPrintf0 ( "        bucket sorting ...\n" );
        //for (i = 0; i < 257;    i++) ftab[i] = 0;
        //System.arraycopy(earray, 0, ftab, 0, earray.length -1);
        //for(i = 0; i < 257; i++) ftab[i] = 0;
        for (i = 0; i < nblock; i++){
            ftab[eclass8[i] & 0xff]++;
        }
        //for (i = 0; i < 256;    i++) ftabCopy[i] = ftab[i];
        //System.arraycopy(ftab, 0, ftabCopy, 0, 256);
        for (i = 1; i < 257;    i++) ftab[i] += ftab[i-1];
        fmap.complexPut(nblock, eclass8, ftab);
        //for (i = 0; i < nblock; i++) {
	//  j = eclass8[i] & 0xff;//eclass8[i] < 0? eclass8[i] & 0xff: eclass8[i];
	//  k = ftab[j] - 1;
            //ftab[j] = k;
	//  ftab[j] = k;
            //fmap[k] = i;
            //fmap.put(k, i);
            //_fmap.putInt(k * 4, i);
	//  fmap.put(k, i);
        //}

        nBhtab = 2 + (nblock / 32);
        //for (i = 0; i < nBhtab; i++) bhtab.put(i,0);
        bhtab.nullify(nBhtab);
        //for (i = 0; i < 256;){
            //SET_BH(ftab[i]);
            //bhtab[ftab[i] >> 5] |= (1 << ((ftab[i]) & 31));
            //int fti = ftab[i];
            //int index = fti >> 5;
            //long value = bhtab.getUInt32(index);//toUInt32(bhtab.get(index));
            //value |= (1 << (fti & 31));
            //bhtab.put(index, (int)value);
	//  bhtab.SET(ftab[i++]);
        //} 
        bhtab.lenSET(256, ftab);

        /**--
            Inductively refine the buckets.  Kind-of an
            "exponential radix sort" (!), inspired by the
            Manber-Myers suffix array construction algorithm.
         --*/

        /*-- set sentinel bits for block-end detection --*/
	//#define       SET_BH(zz)  bhtab[(zz) >> 5] |= (1 << ((zz) & 31))
	//#define     CLEAR_BH(zz)  bhtab[(zz) >> 5] &= ~(1 << ((zz) & 31))
	//for (i = 0; i < 32; i++) { 
           //SET_BH(nblock + 2*i);
           //int base = nblock + 2 * i;
           //int _bhi = (base >> 5);
           //bhtab.put(_bhi, bhtab.get(_bhi) | (1 << (base & 31)));
	// int nib = nblock + 2 * i;
           //bhtab.SET(nblock + 2*i);
	// bhtab.SET(nib); bhtab.CLEAR(nib + 1);
           //bhtab.CLEAR(nblock + 2 * i + 1);
           //CLEAR_BH(nblock + 2*i + 1);
           //int base =  nblock + 2 * i + 1;
           //int _bhi = base >> 5;
           //bhtab.put(_bhi, bhtab.get(_bhi) & ~(1 << (base & 31)));
	//}
        bhtab.setClear(nblock);

        byte[] farray = fmap.b;
        byte[] bharray = bhtab.b;
        /*-- the log(N) loop --*/
        H = 1;
        while (true) {
            //if (verb >= 4) 
            //VPrintf1 ( "        depth %6d has ", H );
            j = 0;
           
            for (i = 0; i < nblock; i++) {
	        //if (ISSET_BH(i)) j = i;
	        //if((toUInt32(bhtab.get((i) >> 5)) & (1 << ((i) & 31))) != 0){
                //if((bhtab.getUInt32((i)>>5) & (1 << ((i) & 31))) != 0){
                //if(bhtab.ISSET(i)){
                //    j = i;
	        //}
                int zz2 = (i>> 5) << 2;
                if((((((long)(bharray[zz2++] & 0xff) << 24) | 
                      ((bharray[zz2++] & 0xff)<<16) | 
                      ((bharray[zz2++] & 0xff) << 8) | 
                       (bharray[zz2] & 0xff)) & 
		       (1 << ((i) & 31))) != 0)) j = i;
	       //k = fmap.get(i) - H; 
	       //k = _fmap.getInt(i * 4) - H;
               //k = fmap.get(i) - H;
               zz2 = i << 2;
               k = (int)((((long)(farray[zz2++] & 0xff) << 24) | ((farray[zz2++] & 0xff)<<16)| 
			  ((farray[zz2++] & 0xff)<<8) | (farray[zz2] & 0xff)) - H);
               if (k < 0) k += nblock;
               //eclass.put(k, j);
               //_eclass.putInt(k * 4, j);
               //eclass.put(k, j);
               k <<= 2;
               eclass8[k++] = (byte)(j >> 24);
               eclass8[k++] = (byte)(j>> 16);
               eclass8[k++] = (byte)(j>>8);
               eclass8[k] = (byte)j;
           }

           nNotDone = 0;
           r = -1;
           while (true) {
	       /** -- find the next non-singleton bucket --*/
               k = r + 1;
               //while (ISSET_BH(k) && UNALIGNED_BH(k)) k++;
               //while(((bhtab.getUInt32((k) >> 5)  & (1 << ((k) & 31))) != 0) &&
               //while(bhtab.ISSET(k) && (((k) & 0x01f) != 0)) k++;
               int zz2 = (k>> 5) << 2;
               while((((k) & 0x01f) != 0) && 
		     //bhtab.ISSET(k)) k++;
                     (((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
                      (bharray[zz2] & 0xff)) & 
		       (1 << ((k) & 31))) != 0)){
		   k++;
                   zz2 = (k>> 5) << 2;
               }
               //if (ISSET_BH(k)) {
	       //if((bhtab.getUInt32((k) >> 5) & (1 << ((k) & 31))) != 0){
               if(bhtab.ISSET(k)){
	           //while (WORD_BH(k) == 0xffffffff) k += 32;
	           //while(bhtab.getUInt32((k) >> 5) == 0xffffffffL) k += 32;
                   zz2 = (k>> 5) << 2;
                   while((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
			  (bharray[zz2] & 0xff)) == 0xffffffffL){
                          k+= 32;
                          zz2 = (k>> 5) << 2;
                   }
                   //while (ISSET_BH(k)) k++;
                   //while((bhtab.getUInt32((k) >> 5) & (1 << ((k) & 31))) != 0) k++;
                   zz2 = (k>> 5) << 2;
                   while((((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
                      (bharray[zz2] & 0xff)) & 
		      (1 << ((k) & 31))) != 0)){
                       k++;
                       zz2 = (k>> 5) << 2;
                   }
                   //while(bhtab.ISSET(k)) k++;
               }
               l = k - 1;
               if (l >= nblock) break;
               //while (!ISSET_BH(k) && UNALIGNED_BH(k)) k++;
               //int k2 = k;
               //while((((bhtab.getUInt32((k) >> 5)) & (1 << ((k) & 31))) == 0) && 
               //while(!bhtab.ISSET(k) && (((k) & 0x01f) != 0)) k++;
               zz2 = (k>> 5) << 2;
               while((((k) & 0x01f) != 0) && 
		     //!bhtab.ISSET(k)) k++;
    //bhtab.ISSET(k)) k++;
                     (((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
                      (bharray[zz2] & 0xff)) & 
		       (1 << ((k) & 31))) == 0)){
		   k++;
                   zz2 = (k>> 5) << 2;

               }
	       //if (!ISSET_BH(k)) {
	       //if((bhtab.getUInt32((k) >> 5) & (1 << ((k) & 31))) == 0){
               if(!bhtab.ISSET(k)){
	           //while (WORD_BH(k) == 0x00000000) k += 32;
	           //while(bhtab.getUInt32((k) >> 5) == 0x00000000L) k += 32;
                   zz2 = (k>> 5) << 2;
                   while((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
			  (bharray[zz2] & 0xff)) == 0x00000000L){
                          k+= 32;
                          zz2 = (k>> 5) << 2;
                   }
                   //while (!ISSET_BH(k)) k++;
                   //while(((bhtab.getUInt32((k) >> 5)) & (1 << ((k) & 31))) == 0) k++;
                   //while(!bhtab.ISSET(k)) k++;
                   zz2 = (k>> 5) << 2;
                   while((((((long)(bharray[zz2++] & 0xff) << 24) | 
                     ((bharray[zz2++] & 0xff)<<16) | 
                     ((bharray[zz2++] & 0xff) << 8) | 
                      (bharray[zz2] & 0xff)) & 
		      (1 << ((k) & 31))) == 0)){
                       k++;
                       zz2 = (k>> 5) << 2;
                   }
               }
               r = k - 1;
               if (r >= nblock) break;

               /** -- now [l, r] bracket current bucket --*/
               if (r > l) {
                   nNotDone += (r - l + 1);
                   fallbackQSort3 (fmap, eclass, l, r );
                   /** -- scan bucket and generate header bits-- */
                   cc = -1;
                   for (i = l; i <= r; i++) {
	               //cc1 = _eclass.getInt(_fmap.getInt(i * 4) * 4);
                       int i2 = i << 2;
                       int fi = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                                ((farray[i2++] & 0xff)<<16)| 
	                        ((farray[i2++] & 0xff)<<8)|
			   (farray[i2] & 0xff));
                       i2 = fi << 2;
                       //cc1 = eclass.get(fmap.get(i));//_eclass.getInt(fmap.get(i) * 4);
                       cc1 =  ((eclass8[i2++] & 0xff) << 24) | 
                              ((eclass8[i2++] & 0xff)<<16)| 
	                      ((eclass8[i2++] & 0xff)<<8)|
	                      (eclass8[i2] & 0xff);
                       if (cc != cc1) { 
		           //SET_BH(i);
                           //int _i = i >> 5; 
		           //bhtab.put(_i, (int)((bhtab.getUInt32(_i)) | (1 << ((i) & 31))));
                           //bhtab.SET(i);
                          zz2 = (i >> 5) << 2;
                          int j2 = (1 << ((i) & 31));
                          bharray[zz2++] |= (j2 >> 24);
                          bharray[zz2++] |= (j2 >> 16);
                          bharray[zz2++] |= (j2 >> 8);
                          bharray[zz2] |= j2;
                           cc = cc1; 
                       }
                    }
	       }
	   }

            //if (verb >= 4) 
            // VPrintf1 ( "%6d unresolved strings\n", nNotDone );

            H *= 2;
            if (H > nblock || nNotDone == 0) break;
       }

       /**-- 
        Reconstruct the original block in
        eclass8 [0 .. nblock-1], since the
        previous phase destroyed it.
        --*/
        //if (verb >= 4)
        // VPrintf0 ( "        reconstructing block ...\n" );
        //j = 0;
        /** for (i = 0; i < nblock; i++) {
          while (ftabCopy[j] == 0) j++;
          ftabCopy[j]--;
          //int fi = _fmap.getInt(i * 4);
          //int fi = fmap.get(i);
          //eclass8[fi] = (byte)j;
          int fi = fmap.get(i);
          eclass8[fi] = (byte)j;
	     //eclass8[fmap.get(i)] = (byte)j;
        } */
       //System.arraycopy(eclass8_2, 0, eclass8, 0, eclass8.length);
       eclass.restore();
        //AssertH ( j < 256, 1005 );

    }

    public static final int FALLBACK_QSORT_SMALL_THRESH = 10;
    public static final int FALLBACK_QSORT_STACK_SIZE = 100;

    public static void fallbackQSort3(IntView fmap, IntView eclass, int loSt, int hiSt){
        int unLo, unHi, ltLo, gtHi, n, m;
        int sp, lo, hi;
        long med, r, r3;
        int stackLo[] = new int[FALLBACK_QSORT_STACK_SIZE];
        int stackHi[] = new int[FALLBACK_QSORT_STACK_SIZE];

        int yyp1, yyp2, yyn;
        byte b1, b2, b3, b4;

        r = 0;
        sp = 0; 
        //fpush ( loSt, hiSt );
        stackLo[sp] = loSt; 
        stackHi[sp] = hiSt; 
        //sp++;
        sp = 1;

        byte[] eclass8 = eclass.b;
        byte[] farray = fmap.b;
        while (sp > 0) {
           //AssertH ( sp < FALLBACK_QSORT_STACK_SIZE - 1, 1004 );
           //fpop ( lo, hi );
           sp--;              
           lo = stackLo[sp];
           hi = stackHi[sp];
           if (hi - lo < FALLBACK_QSORT_SMALL_THRESH) {
               fallbackSimpleSort ( farray, eclass8, lo, hi );
               continue;
           }

          /* Random partitioning.  Median of 3 sometimes fails to
             avoid bad cases.  Median of 9 seems to help but 
             looks rather expensive.  This too seems to work but
             is cheaper.  Guidance for the magic constants 
             7621 and 32768 is taken from Sedgewick's algorithms
             book, chapter 35.
          */
	  r = ((r * 7621) + 1) % 32768;
          r3 = r % 3;
          if (r3 == 0){ 
               int i = lo << 2;
               i = (int)(((long)((farray[i++] & 0xff) << 24) | 
                   ((farray[i++] & 0xff)<<16)| 
	           ((farray[i++] & 0xff)<<8)|
			  (farray[i] & 0xff)) << 2);
              med = (((eclass8[i++] & 0xff) << 24)|
	             ((eclass8[i++] & 0xff) << 16)|
	             ((eclass8[i++] & 0xff) << 8)|
	             (eclass8[i] & 0xff));
	      //med = eclass.getUInt32(fmap.get(lo));//eclass[(int)fmap[lo]]; 
          }
          else if (r3 == 1){
	      int i = ((lo + hi)>>1) << 2;
	      i = (int)((((long)(farray[i++] & 0xff) << 24) | 
                   ((farray[i++] & 0xff)<<16)| 
	           ((farray[i++] & 0xff)<<8)|
			 (farray[i] & 0xff)) << 2);
              med = (((eclass8[i++] & 0xff) << 24)|
	             ((eclass8[i++] & 0xff) << 16)|
	             ((eclass8[i++] & 0xff) << 8)|
	             (eclass8[i] & 0xff));
	      //med = eclass.getUInt32(fmap.get((lo+hi)>>1));//eclass[(int)fmap[(lo+hi)>>1]]; 
          }
          else{
	      int i = hi << 2;
	      i = (int)((((long)(farray[i++] & 0xff) << 24) | 
                   ((farray[i++] & 0xff)<<16)| 
	           ((farray[i++] & 0xff)<<8)|
		    (farray[i] & 0xff)) << 2);
              med = (((eclass8[i++] & 0xff) << 24)|
	             ((eclass8[i++] & 0xff) << 16)|
	             ((eclass8[i++] & 0xff) << 8)|
	             (eclass8[i] & 0xff));
	      //med = eclass.getUInt32(fmap.get(hi));//eclass[(int)fmap[hi]];
          }              

          unLo = ltLo = lo;
          unHi = gtHi = hi;

          while (true) {
             while (true) {
                if (unLo > unHi) break;
	         int i = unLo << 2;
                 i = (int)((((long)(farray[i++] & 0xff) << 24) | 
                      ((farray[i++] & 0xff)<<16)| 
	              ((farray[i++] & 0xff)<<8)|
			    (farray[i] & 0xff)) << 2);
                 n = (((eclass8[i++] & 0xff) << 24)|
	             ((eclass8[i++] & 0xff) << 16)|
	             ((eclass8[i++] & 0xff) << 8)|
		      (eclass8[i] & 0xff)) - (int)med;
		 //n = eclass.get(fmap.get(unLo)) - (int)med;//(int)eclass[(int)fmap[unLo]] - (int)med;aave
                
                if (n == 0) { 
		    //fswap(fmap[unLo], fmap[ltLo]); 
                    //fmap.fswap(unLo, ltLo);
                    int zz1 = unLo << 2;
                    b1 = farray[zz1]; b2 = farray[zz1+1]; b3=farray[zz1+2]; b4=farray[zz1+3];
                    int zz2 = ltLo << 2;
                    farray[zz1] = farray[zz2]; farray[zz1+1] = farray[zz2 + 1]; 
                    farray[zz1+2] = farray[zz2 + 2]; farray[zz1+3] = farray[zz2+3];
                    farray[zz2] = b1; farray[zz2+1] = b2; farray[zz2+2] = b3; farray[zz2+3] = b4;
		    //int zztmp = fmap.get(unLo); 
                   //fmap[unLo] = fmap[ltLo];//zz2; 
                   //fmap.put(unLo, fmap.get(ltLo));
                   //zz2 = zztmp;
                   //fmap[ltLo] = zztmp;
                   //fmap.put(ltLo, zztmp);
                   ltLo++; unLo++; 
                   continue; 
                }
                if (n > 0) break;
                unLo++;
             }
             while (true) {
                 if (unLo > unHi) break;
                 //n = (int)eclass[(int)fmap[unHi]] - (int)med;
                 //n = eclass.get(fmap.get(unHi)) - (int)med;
	         int i = unHi << 2;
                 i = (int)((((long)(farray[i++] & 0xff) << 24) | 
                      ((farray[i++] & 0xff)<<16)| 
	              ((farray[i++] & 0xff)<<8)|
			    (farray[i] & 0xff)) << 2);
                 n = (((eclass8[i++] & 0xff) << 24)|
	             ((eclass8[i++] & 0xff) << 16)|
	             ((eclass8[i++] & 0xff) << 8)|
		      (eclass8[i] & 0xff)) - (int)med;
                 if (n == 0) { 
		    //fswap(fmap[unHi], fmap[gtHi]); 
		    //fmap.fswap(unHi, gtHi);
                    int zz1 = unHi << 2;
                    b1 = farray[zz1]; b2 = farray[zz1+1]; b3=farray[zz1+2]; b4=farray[zz1+3];
                    int zz2 = gtHi << 2;
                    farray[zz1] = farray[zz2]; farray[zz1+1] = farray[zz2 + 1]; 
                    farray[zz1+2] = farray[zz2 + 2]; farray[zz1+3] = farray[zz2+3];
                    farray[zz2] = b1; farray[zz2+1] = b2; farray[zz2+2] = b3; farray[zz2+3] = b4;
		    //int zztmp = fmap.get(unHi); //fmap[unHi];
                    //fmap[gtHi] = fmap[gtHi];
                    //fmap.put(unHi, fmap.get(gtHi));
                    //fmap[unHi] = zztmp;
                    //fmap.put(gtHi, zztmp);
                    gtHi--; unHi--; 
                    continue; 
	     }
             if (n < 0) break;
             unHi--;
          }
          if (unLo > unHi) break;
          //fswap(fmap[unLo], fmap[unHi]); 
          //fmap.fswap(unLo, unHi);
          int zz1 = unLo << 2;
          b1 = farray[zz1]; b2 = farray[zz1+1]; b3=farray[zz1+2]; b4=farray[zz1+3];
          int zz2 = unHi << 2;
          farray[zz1] = farray[zz2]; farray[zz1+1] = farray[zz2 + 1]; 
          farray[zz1+2] = farray[zz2 + 2]; farray[zz1+3] = farray[zz2+3];
          farray[zz2] = b1; farray[zz2+1] = b2; farray[zz2+2] = b3; farray[zz2+3] = b4;
          //int zztmp = fmap.get(unLo);//fmap[unLo];
          //fmap[unLo] = fmap[unHi];
          //fmap.put(unLo, fmap.get(unHi));
          //fmap[unHi] = zztmp;
          //fmap.put(unHi, zztmp);
          unLo++; unHi--;
       }

        //AssertD ( unHi == unLo-1, "fallbackQSort3(2)" );
 
        if (gtHi < ltLo) continue;

        //n = fmin(ltLo-lo, unLo-ltLo);
        int fm1 = ltLo - lo; int fm2 = unLo - ltLo; 
        n = fm1 < fm2? fm1: fm2;
        //n = ((ltLo - lo) < (unLo-ltLo))? ltLo-lo: unLo -ltLo;
        //fmap.fvswap(lo, unLo - n, n);
        yyp1 = lo << 2; 
        yyp2 = (unLo - n) << 2;
        yyn  = n;
        while (yyn > 0) {
            //zz1 = yyp1 * 4; zz2 = yyp2 * 4;
            b1 = farray[yyp1]; b2 = farray[yyp1+1]; b3=farray[yyp1+2]; b4=farray[yyp1+3]; 
            farray[yyp1] = farray[yyp2]; farray[yyp1+1] = farray[yyp2 + 1]; 
            farray[yyp1+2] = farray[yyp2 + 2]; farray[yyp1+3] = farray[yyp2+3];
            farray[yyp2] = b1; farray[yyp2+1] = b2; farray[yyp2+2] = b3; farray[yyp2+3] = b4;     
            yyp1 += 4; yyp2 += 4; yyn--;
        }  
        //fvswap(lo, unLo-n, n);
        //int yyp1 = lo;               
        //int yyp2 = unLo - n;               
        //int yyn  = n;                
        //while (yyn > 0) {                  
	    //fswap(fmap[yyp1], fmap[yyp2]);  
	//  fmap.fswap(yyp1, yyp2);
	    //int zztmp = fmap.get(yyp1);//fmap[yyp1];
            //fmap[yyp1] = fmap[yyp2];
            //fmap.put(yyp1, fmap.get(yyp2));
            //fmap[yyp2] = zztmp;
            //fmap.put(yyp2, zztmp);            
	//  yyp1++; yyp2++; yyn--;          
        //}  
        fm1 = hi - gtHi; fm2 =  gtHi - unHi;//unLo - ltLo;  
        //m = (hi - gtHi) < (gtHi-unHi)? hi-gtHi: gtHi-unHi;//fmin(hi-gtHi, gtHi-unHi); 
        m = fm1 < fm2? fm1: fm2;
        //fvswap(unLo, hi-m+1, m);
        //fmap.fvswap(unLo, hi-m+1, m);
        yyp1 = unLo << 2; 
        yyp2 = (hi - m + 1) << 2;
        yyn  = m;
        while (yyn > 0) {
            //zz1 = yyp1 * 4; zz2 = yyp2 * 4;
            b1 = farray[yyp1]; b2 = farray[yyp1+1]; b3=farray[yyp1+2]; b4=farray[yyp1+3]; 
            farray[yyp1] = farray[yyp2]; farray[yyp1+1] = farray[yyp2 + 1]; 
            farray[yyp1+2] = farray[yyp2 + 2]; farray[yyp1+3] = farray[yyp2+3];
            farray[yyp2] = b1; farray[yyp2+1] = b2; farray[yyp2+2] = b3; farray[yyp2+3] = b4;     
            yyp1 += 4; yyp2 += 4; yyn--;
        }             
        //while (yyn > 0) {                  
	    //fswap(fmap[yyp1], fmap[yyp2]);  
	//  fmap.fswap(yyp1, yyp2);
	    //int zztmp = fmap.get(yyp1);//fmap[yyp1];
            //fmap[yyp1] = fmap[yyp2];
            //fmap.put(yyp1, fmap.get(yyp2));
            //fmap[yyp2] = zztmp;
            //fmap.put(yyp2, zztmp);
	// yyp1++; yyp2++; yyn--;          
        //}

        n = lo + unLo - ltLo - 1;
        m = hi - (gtHi - unHi) + 1;

        if (n - lo > hi - m) {
	    //fpush ( lo, n );
	    stackLo[sp] = lo;
            stackHi[sp] = n;
            sp++;
            //fpush ( m, hi );
	    stackLo[sp] = m;
            stackHi[sp] = hi;
            sp++;
        } else {
	    //fpush ( m, hi );
	    stackLo[sp] = m;
            stackHi[sp] = hi;
            sp++;
            //fpush ( lo, n );
            stackLo[sp] = lo;
            stackHi[sp] = n;
            sp++;
        }
     }
   }


    //static int rsort = 0;
    //static int fmaps = 0;
   public static void fallbackSimpleSort (byte[] farray, byte[] eclass8, int lo, int hi ){
       //IntBuffer fmap = _fmap.asIntBuffer(); //UINT32
       //IntBuffer eclass = _eclass.asIntBuffer(); //UINT32
       int i, j, tmp; //INT32
       long ec_tmp; //UINT32
       if (lo == hi) return;
       int tmp2; long ec_tmp2;
       //byte[] eclass8 = eclass.b;
       //byte[] farray = fmap.b;
       if (hi - lo > 3) {
           for ( i = hi-4; i >= lo; i-- ) {
	       //tmp = fmap.get(i);//(int)fmap[i];
              int i2 = i << 2;
              tmp = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                    ((farray[i2++] & 0xff)<<16)| 
	             ((farray[i2++] & 0xff)<<8)|
			  (farray[i2] & 0xff));
	      //fmap.storeTmp(i);
              i2 = tmp << 2;
              ec_tmp = ((eclass8[i2++] & 0xff) << 24) | 
		  ((eclass8[i2++] & 0xff)<<16)| 
	             ((eclass8[i2++] & 0xff)<<8)|
	             (eclass8[i2] & 0xff);
           j = i + 4;
           i2 = j << 2;
           tmp2 = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                 ((farray[i2++] & 0xff)<<16)| 
	         ((farray[i2++] & 0xff)<<8)|
			(farray[i2] & 0xff));
           i2 = tmp2 << 2;
           ec_tmp2 = ((long)(eclass8[i2++] & 0xff) << 24) | 
                    ((eclass8[i2++] & 0xff)<<16)| 
	            ((eclass8[i2++] & 0xff)<<8)|
	             (eclass8[i2] & 0xff);
              //ec_tmp = eclass.getUInt32(tmp);//toUInt32(_eclass.getInt(i * 4));//eclass[tmp];
              //for ( j = i+4; j <= hi && ec_tmp > eclass.getUInt32(fmap.get(j)); j += 4 ){
              while(j <= hi && ec_tmp > ec_tmp2){

		  //fmap.put(j-4, fmap.get(j));//fmap[j-4] = fmap[j];
                  //fmap.put(j - 4, fmap.get(j));
                  //fmap.iput(j-4, j);
                  i2 = (j-4) << 2; int j2 = j << 2;
                  farray[i2++] = farray[j2++];
                  farray[i2++] = farray[j2++];
                  farray[i2++] = farray[j2++];
                  farray[i2] = farray[j2];
                  j += 4;
           i2 = j << 2;
           tmp2 = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                 ((farray[i2++] & 0xff)<<16)| 
	         ((farray[i2++] & 0xff)<<8)|
			(farray[i2] & 0xff));
           i2 = tmp2 << 2;
           ec_tmp2 = ((long)(eclass8[i2++] & 0xff) << 24) | 
                    ((eclass8[i2++] & 0xff)<<16)| 
	            ((eclass8[i2++] & 0xff)<<8)|
	             (eclass8[i2] & 0xff);
              }
              //fmap[j-4] = tmp;
              //fmap.put(j-4, tmp);
              //_fmap.putInt((j*4) - 16, tmp);
              //fmap.put(j - 4, tmp);
              i2 = (j-4) << 2;
              farray[i2++] = (byte)(tmp >> 24);
              farray[i2++] = (byte)(tmp>> 16);
              farray[i2++] = (byte)(tmp>>8);
              farray[i2] = (byte)tmp;
              //fmap.saveTmp(j-4);
 
          }
       }

       for ( i = hi-1; i >= lo; i-- ) {
           //tmp = fmap.get(i);//_fmap.getInt(i * 4);//(int)fmap[i];
           int i2 = i << 2;
           tmp = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                 ((farray[i2++] & 0xff)<<16)| 
	         ((farray[i2++] & 0xff)<<8)|
		       (farray[i2] & 0xff));
           //fmap.storeTmp(i);
           //ec_tmp = eclass.getUInt32(tmp);//eclass[tmp];
           i2 = tmp << 2;
           ec_tmp = ((long)(eclass8[i2++] & 0xff) << 24) | 
                    ((eclass8[i2++] & 0xff)<<16)| 
	            ((eclass8[i2++] & 0xff)<<8)|
	             (eclass8[i2] & 0xff);
           j = i + 1;
           i2 = j << 2;
           tmp2 = (int)(((long)(farray[i2++] & 0xff) << 24) | 
                 ((farray[i2++] & 0xff)<<16)| 
	         ((farray[i2++] & 0xff)<<8)|
			(farray[i2] & 0xff));
           i2 = tmp2 << 2;
           ec_tmp2 = ((long)(eclass8[i2++] & 0xff) << 24) | 
                    ((eclass8[i2++] & 0xff)<<16)| 
	            ((eclass8[i2++] & 0xff)<<8)|
	             (eclass8[i2] & 0xff);
           //for (; j <= hi && ec_tmp > eclass.getUInt32(fmap.get(j)); j++ ){
           while(j <= hi && ec_tmp > ec_tmp2){
               //fmap.put(j-1, fmap.get(j));
               //_fmap.putInt((j * 4) - 4, _fmap.getInt(j * 4));
               //fmap.put(j-1, fmap.get(j));
               //fmap.iput(j-1, j);
               i2 = (j-1) << 2; int j2 = j << 2;
               farray[i2++] = farray[j2++];
               farray[i2++] = farray[j2++];
               farray[i2++] = farray[j2++];
               farray[i2] = farray[j2];
               j++;
               i2 = j << 2;
               tmp2 = ((farray[i2++] & 0xff) << 24) | 
                     ((farray[i2++] & 0xff)<<16)| 
	             ((farray[i2++] & 0xff)<<8)|
	              (farray[i2] & 0xff);
                i2 = tmp2 << 2;
                ec_tmp2 = ((eclass8[i2++] & 0xff) << 24) | 
                          ((eclass8[i2++] & 0xff)<<16)| 
	                  ((eclass8[i2++] & 0xff)<<8)|
	                  (eclass8[i2] & 0xff);
           }
           //fmap.put(j-1, tmp);
           //_fmap.putInt((j *4) -4, tmp);
           //fmap.put(j -1, tmp);
           i2 = (j-1) << 2;
           farray[i2++] = (byte)(tmp >> 24);
           farray[i2++] = (byte)(tmp>> 16);
           farray[i2++] = (byte)(tmp>>8);
           farray[i2] = (byte)tmp;
           //fmap.saveTmp(j-1);
       }
    }


    public static boolean mainGtU (long _i1, 
                                  long  _i2,
                                  byte[] block, 
				  ShortView quadrant,
                                  long  nblock,
                                  int[] budget ){
        int  k;
        int  c1, c2;
        int s1, s2;
        int i1 = (int)_i1; int i2 = (int)_i2;
        //AssertD ( i1 != i2, "mainGtU" );
        /* 1 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //byte b1, b2;

        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        if(block[i1] != block[i2]){
           return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
	    //if (c1 != c2) return (c1 > c2);
        i1++; i2++;
        /* 2 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
            return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 3 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
           return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 4 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
            return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 5 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
             return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 6 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]) {
           return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 7 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
             return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 8 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]) {
             return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 9 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
            return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 10 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
            return (block[i1] & 0xff) > (block[i2] & 0xff);
        }
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 11 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
              return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;
        /* 12 */
        //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
        //if (c1 != c2) return (c1 > c2);
        if(block[i1] != block[i2]){
              return (block[i1] & 0xff) > (block[i2] & 0xff);
	}
        //b1 = block[i1]; b2 = block[i2];
        //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
        i1++; i2++;

        k = (int)(nblock + 8);
       
       byte[] b = quadrant.b;
       int start = quadrant.start;//getStart();
       int start2 = start + 1;
       //int i3 = (i1 << 1) + start;
       //int i4 = (i2 << 1) + start;

       //byte b1, b2, b3, b4;
       int a1, a2, a3, a4;
       
       do {
          /* 1 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
	   if(block[i1] != block[i2]){
              return (block[i1] & 0xff) > (block[i2] & 0xff);
	   }
	   //b1 = block[i1]; b2 = block[i2];
	   //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
	   //b1 = b[i3++]; b2 = b[i3++]; b3 = b[i4++]; b4 = b[i4++];
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
               //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //  (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //       (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
	       //if(b1 != b3 || b2 != b4){
               //return (((b1 & 0xff) << 8)| (b2 & 0xff))
	       //               >
		   // ..     (((b3 & 0xff) << 8)| (b4 & 0xff));

	       //return quadrant.ui_gt(i1,i2);
	   }
	  i1++; i2++;
          /* 2 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
                return (block[i1] & 0xff) > (block[i2] & 0xff);
          }

	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
               //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //  (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //       (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
	   // return quadrant.ui_gt(i1,i2);
	   //}

	   }
          i1++; i2++;
          /* 3 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
             return (block[i1] & 0xff) > (block[i2] & 0xff);
	  }


	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){ 
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
	       //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       // (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));

	  //  return quadrant.ui_gt(i1, i2);
	  }
          i1++; i2++;
          /* 4 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
                return (block[i1] & 0xff) > (block[i2] & 0xff);
	  }
	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
               //return quadrant.ui_gt(i1,i2);
               //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //      (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
          }
          i1++; i2++;
          /* 5 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
              return (block[i1] & 0xff) > (block[i2] & 0xff);
	  }
	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
              //return quadrant.ui_gt(i1,i2);
               //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //  (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
          }
          i1++; i2++;
          /* 6 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
               return (block[i1] & 0xff) > (block[i2] & 0xff);
          }
	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
	      //return quadrant.ui_gt(i1,i2);
	      //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //        (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       // (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
	  }
          i1++; i2++;
          /* 7 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
              return (block[i1] & 0xff) > (block[i2] & 0xff);
	  }
	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]){
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
              //return quadrant.ui_gt(i1, i2);
              // return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //        (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //  (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
	  }
          i1++; i2++;
          /* 8 */
          //c1 = block[i1] & 0xff; c2 = block[i2] & 0xff;
          //if (c1 != c2) return (c1 > c2);
          if(block[i1] != block[i2]){
               return (block[i1] & 0xff) > (block[i2] & 0xff);
          }
	  //b1 = block[i1]; b2 = block[i2];
	  //if(b1 != b2) return (b1 & 0xff) > (b2 & 0xff);
          //s1 = quadrant.getUInt16(i1); s2 = quadrant.getUInt16(i2);
          //if (s1 != s2) return (s1 > s2);
          //if(b[(i1 * 2) + start] != b[(i2 * 2) + start]) {
           a1 = (i1 << 1) + start;
           a2 = (i1 << 1) + start2;
           a3 = (i2 << 1) + start;
           a4 = (i2 << 1) + start2;
	   //if(b[(i1 << 1) + start] != b[(i2 << 1) + start] || b[(i1 << 1) + start2] != b[(i2 << 1) + start2] ){
           if(b[a1] != b[a3] || b[a2] != b[a4]){
              //return quadrant.ui_gt(i1, i2);
               //return  (((b[(i1 << 1) + start] & 0xff) << 8) |
	       //       (b[(i1 << 1) + start2] & 0xff))
	       //                   >
	       //     (((b[(i2 << 1) + start] & 0xff) << 8) |
	       //        (b[(i2 << 1) + start2] & 0xff));
               return (((b[a1] & 0xff) << 8) | (b[a2] & 0xff))
                                    >
		      (((b[a3] & 0xff) << 8) | (b[a4] & 0xff));
          }
          i1++; i2++;

          if (i1 >= nblock) i1 -= nblock;
          if (i2 >= nblock) i2 -= nblock;

          k -= 8;
          budget[0]--;
       }
       while (k >= 0);
       return false;
    }

    /*---------------------------------------------*/
    /*--
    Knuth's increments seem to work better
    than Incerpi-Sedgewick here.  Possibly
    because the number of elems to sort is
    usually small, typically <= 20.
    --*/
    public static int[] incs = { 1, 4, 13, 40, 121, 364, 1093, 3280,
                   9841, 29524, 88573, 265720,
                   797161, 2391484 };

    public static void mainSimpleSort (IntView ptr,
                      byte[]  block,
                      ShortView quadrant,
                      int   nblock,
                      int   lo, 
                      int   hi, 
                      int   d,
                      int[] budget ){
        int i, j, h, bigN, hp;
        long v, _v2;

        byte[] parray = ptr.b;
        int _sb, _sb2, _v;

        bigN = hi - lo + 1;
        if (bigN < 2) return;

        hp = 0;
        while (incs[hp] < bigN) hp++;
        hp--;

        for (; hp >= 0; hp--) {
            h = incs[hp];

            i = lo + h;
            while (true) {
                /*-- copy 1 --*/
                if (i > hi){
                    break;
                }
                //v = ptr.getUInt32(i);
                _sb = i << 2;
                v = (((long)(parray[_sb++] & 0xff) << 24)|
	             ((parray[_sb++] & 0xff) << 16)|
	             ((parray[_sb++] & 0xff) << 8)|
		      (parray[_sb] & 0xff));

                j = i;

	        _sb = (j-h) << 2;
                while ( mainGtU ( 
			      //ptr.getUInt32(j-h)+d, 
				 (((long)(parray[_sb++] & 0xff) << 24)|
	                         ((parray[_sb++] & 0xff) << 16)|
	                         ((parray[_sb++] & 0xff) << 8)|
		                  (parray[_sb] & 0xff)) + d,
                        v+d, block, quadrant, nblock, budget 
                 ) ) {
		 //ptr.put(j, ptr.get(j-h));
                 _sb = j << 2;
                 _sb2 = (j - h) << 2;
                 _v2 = (((long)(parray[_sb2++] & 0xff) << 24)|
	             ((parray[_sb2++] & 0xff) << 16)|
	             ((parray[_sb2++] & 0xff) << 8)|
		       (parray[_sb2] & 0xff));
                 parray[_sb++] = (byte)(_v2 >> 24);
                 parray[_sb++] = (byte)(_v2>> 16);
                 parray[_sb++] = (byte)(_v2>>8);
                 parray[_sb] = (byte)_v2;

                j = j - h;
                if (j <= (lo + h - 1)) break;
                _sb = (j -h) << 2;
	    }
	     //ptr.put(j, (int)v);
             _v = (int)v;
             _sb = j << 2;
             parray[_sb++] = (byte)(_v >> 24);
             parray[_sb++] = (byte)(_v>> 16);
             parray[_sb++] = (byte)(_v>>8);
             parray[_sb] = (byte)_v;
             i++;

            /*-- copy 2 --*/
            if (i > hi) break;
            //v = ptr.getUInt32(i);
            _sb = i << 2;
            v = (((long)(parray[_sb++] & 0xff) << 24)|
	        ((parray[_sb++] & 0xff) << 16)|
	        ((parray[_sb++] & 0xff) << 8)|
		 (parray[_sb] & 0xff));
            j = i;
            _sb = (j-h) << 2;
            while ( mainGtU ( 
			     //ptr.getUInt32(j-h)+d, 
			     (((long)(parray[_sb++] & 0xff) << 24)|
	                      ((parray[_sb++] & 0xff) << 16)|
	                      ((parray[_sb++] & 0xff) << 8)|
		               (parray[_sb] & 0xff)) + d,
                       v+d, block, quadrant, nblock, budget 
                 ) ) {
                //ptr.put(j, ptr.get(j-h));
                 _sb = j << 2;
                 _sb2 = (j - h) << 2;
                 _v2 = (((long)(parray[_sb2++] & 0xff) << 24)|
	             ((parray[_sb2++] & 0xff) << 16)|
	             ((parray[_sb2++] & 0xff) << 8)|
		     (parray[_sb2] & 0xff));
                 parray[_sb++] = (byte)(_v2 >> 24);
                 parray[_sb++] = (byte)(_v2>> 16);
                 parray[_sb++] = (byte)(_v2>>8);
                 parray[_sb] = (byte)_v2;
                j = j - h;
                if (j <= (lo + h - 1)) break;
                _sb = (j-h) << 2;
             }
	    //ptr.put(j, (int)v);
             _v = (int)v;
             _sb = j << 2;
             parray[_sb++] = (byte)(_v >> 24);
             parray[_sb++] = (byte)(_v>> 16);
             parray[_sb++] = (byte)(_v>>8);
             parray[_sb] = (byte)_v;
             i++;

             /*-- copy 3 --*/
             if (i > hi) break;
             //v = ptr.getUInt32(i);
            _sb = i << 2;
            v = (((long)(parray[_sb++] & 0xff) << 24)|
	        ((parray[_sb++] & 0xff) << 16)|
	        ((parray[_sb++] & 0xff) << 8)|
		 (parray[_sb] & 0xff));
             j = i;
            _sb = (j-h) << 2;
             while ( mainGtU ( 
			      //ptr.getUInt32(j-h)+d, 
			      (((long)(parray[_sb++] & 0xff) << 24)|
	                      ((parray[_sb++] & 0xff) << 16)|
	                      ((parray[_sb++] & 0xff) << 8)|
		               (parray[_sb] & 0xff)) + d,
                    v+d, block, quadrant, nblock, budget 
                 ) ) {
		 //ptr.put(j, ptr.get(j-h));
                 _sb = j << 2;
                 _sb2 = (j - h) << 2;
                 _v2 = (((long)(parray[_sb2++] & 0xff) << 24)|
	             ((parray[_sb2++] & 0xff) << 16)|
	             ((parray[_sb2++] & 0xff) << 8)|
		     (parray[_sb2] & 0xff));
                 parray[_sb++] = (byte)(_v2 >> 24);
                 parray[_sb++] = (byte)(_v2>> 16);
                 parray[_sb++] = (byte)(_v2>>8);
                 parray[_sb] = (byte)_v2;
                j = j - h;
                if (j <= (lo + h - 1)) break;
                _sb = (j-h) << 2;
             }
             //ptr.put(j,(int)v);
             _v = (int)v;
             _sb = j << 2;
             parray[_sb++] = (byte)(_v >> 24);
             parray[_sb++] = (byte)(_v>> 16);
             parray[_sb++] = (byte)(_v>>8);
             parray[_sb] = (byte)_v;
             i++;
             if (budget[0] < 0) return;
          }
       }
    }

    public static int mmed3 (int a, int b, int c){
        int t;
        if (a > b) { t = a; a = b; b = t; };
        if (b > c) { 
            b = c;
            if (a > b) b = a;
        }
        return b;
    }

    public static int mnextsize(int az, int[] nextHi, int[] nextLo){ return (nextHi[az]-nextLo[az]); }


    public static int MAIN_QSORT_SMALL_THRESH = 20;
    public static int MAIN_QSORT_DEPTH_THRESH = (BZ_N_RADIX + BZ_N_QSORT);
    public static int MAIN_QSORT_STACK_SIZE = 100;


    public static void mainQSort3 (IntView ptr,
                  byte[]  block,
                  ShortView quadrant,
                  int   nblock,
                  int   loSt, 
                  int   hiSt, 
                  int   dSt,
                  int[]  budget ){

        int unLo, unHi, ltLo, gtHi, n, m, med;
        int sp, lo, hi, d;

        int a, b, c;
        byte[] parray = ptr.b;
        int zz1, zz2;

        int stackLo[] = new int[MAIN_QSORT_STACK_SIZE];
        int stackHi[] = new int[MAIN_QSORT_STACK_SIZE];
        int stackD[] = new int[MAIN_QSORT_STACK_SIZE];

        int nextLo[] = new int[3];
        int nextHi[] = new int[3];
        int nextD[] = new int[3];

        sp = 0;
        //mpush ( loSt, hiSt, dSt );
        stackLo[sp] = loSt;
        stackHi[sp] = hiSt;
        stackD [sp] = dSt;
        sp++;
        while (sp > 0) {
            //AssertH ( sp < MAIN_QSORT_STACK_SIZE - 2, 1001 );
            //mpop ( lo, hi, d );
            sp--;
            lo = stackLo[sp]; 
            hi = stackHi[sp]; 
            d = stackD [sp]; 
            if (hi - lo < MAIN_QSORT_SMALL_THRESH || 
                d > MAIN_QSORT_DEPTH_THRESH) {
                mainSimpleSort (ptr, block, quadrant, nblock, lo, hi, d, budget );
                if (budget[0] < 0) return;
                continue;
            }

            //med = (int) 
	    //mmed3( block[ptr.get(lo)+d] & 0xff,
	    //       block[ptr.get(hi)+d] & 0xff,
	    //       block[ptr.get((lo+hi)>>1)+d] & 0xff );
            int _i = lo <<2;
            a = block[(int)(((((long)(parray[_i++] & 0xff) << 24) | 
                      ((parray[_i++] & 0xff)<<16)| 
	              ((parray[_i++] & 0xff)<<8)|
			      (parray[_i] & 0xff)) + d) & UINT32)] & 0xff;
            _i = hi << 2;
            b = block[(int)(((((long)(parray[_i++] & 0xff) << 24) | 
                      ((parray[_i++] & 0xff)<<16)| 
	              ((parray[_i++] & 0xff)<<8)|
			     (parray[_i] & 0xff)) + d) & UINT32)] & 0xff;
            _i = ((lo+hi)>>1) << 2;
            c = block[(int)(((((long)(parray[_i++] & 0xff) << 24) | 
                      ((parray[_i++] & 0xff)<<16)| 
	              ((parray[_i++] & 0xff)<<8)|
			      (parray[_i] & 0xff)) + d) & UINT32)] & 0xff;
            int t;
            if (a > b) { t = a; a = b; b = t; };
            if (b > c) { 
              b = c;
              if (a > b) b = a;
            }
            med = b;
            unLo = ltLo = lo;
            unHi = gtHi = hi;
            while (true) {
                while (true) {
                    if (unLo > unHi) break;
                    _i = unLo << 2;
                    //n = (block[ptr.get(unLo)+d] & 0xff) - med;
                    n = (block[(int)(((((long)(parray[_i++] & 0xff) << 24) | 
                                   ((parray[_i++] & 0xff)<<16)| 
	                            ((parray[_i++] & 0xff)<<8)|
				       (parray[_i] & 0xff)) + d) & UINT32)] & 0xff) - med;
                    if (n == 0) { 
			//mswap(ptr[unLo], ptr[ltLo]);
                        //ptr.fswap(unLo, ltLo);
	                //zz1 *= 4;
                        zz1 = unLo << 2;
                        byte b1 = parray[zz1], b2 = parray[zz1+1], b3=parray[zz1+2], b4=parray[zz1+3];
                        //zz2 *= 4;
                        zz2 = ltLo << 2;
                        parray[zz1] = parray[zz2]; parray[zz1+1] = parray[zz2 + 1]; 
                        parray[zz1+2] = parray[zz2 + 2]; parray[zz1+3] = parray[zz2+3];
                        parray[zz2] = b1; parray[zz2+1] = b2; parray[zz2+2] = b3; parray[zz2+3] = b4;
                        //int zztmp = ptr.get(unLo);
                        //ptr.put(unLo, ptr.get(ltLo));
                        //ptr.put(ltLo, zztmp);
                        //lloinc++;
                        ltLo++; unLo++; continue; 
                    }
                    if (n >  0) break;
                    unLo++;
                }
                while (true) {
                    if (unLo > unHi) break;
                    //n = (block[ptr.get(unHi)+d] & 0xff) - med;
                    _i = unHi << 2;
                    n = (block[(int)(((((long)(parray[_i++] & 0xff) << 24) | 
                                   ((parray[_i++] & 0xff)<<16)| 
	                            ((parray[_i++] & 0xff)<<8)|
				       (parray[_i] & 0xff)) + d) & UINT32)] & 0xff) - med;
                    if (n == 0) { 
                        //mswap(ptr[unHi], ptr[gtHi]); 
                        //int zztmp = ptr.get(unHi);
                        //ptr.put(unHi, ptr.get(gtHi));
                        //ptr.put(gtHi ,zztmp);
                        //ptr.fswap(unHi, gtHi);
                        zz1 = unHi << 2;
                        byte b1 = parray[zz1], b2 = parray[zz1+1], b3=parray[zz1+2], b4=parray[zz1+3];
                        //zz2 *= 4;
                        zz2 = gtHi << 2;
                        parray[zz1] = parray[zz2]; parray[zz1+1] = parray[zz2 + 1]; 
                        parray[zz1+2] = parray[zz2 + 2]; parray[zz1+3] = parray[zz2+3];
                        parray[zz2] = b1; parray[zz2+1] = b2; parray[zz2+2] = b3; parray[zz2+3] = b4;
                        gtHi--; unHi--; continue; 
                    }
                    if (n <  0) break;
                    unHi--;
               }
               if (unLo > unHi) break;
               //mswap(ptr[unLo], ptr[unHi]); 
               //int zztmp = ptr.get(unLo);
               //ptr.put(unLo, ptr.get(unHi));
               //ptr.put(unHi, zztmp);
               //ptr.fswap(unLo, unHi);
               zz1 = unLo << 2;
               byte b1 = parray[zz1], b2 = parray[zz1+1], b3=parray[zz1+2], b4=parray[zz1+3];
               //zz2 *= 4;
               zz2 = unHi << 2;
               parray[zz1] = parray[zz2]; parray[zz1+1] = parray[zz2 + 1]; 
               parray[zz1+2] = parray[zz2 + 2]; parray[zz1+3] = parray[zz2+3];
               parray[zz2] = b1; parray[zz2+1] = b2; parray[zz2+2] = b3; parray[zz2+3] = b4;
               unLo++; unHi--;
	    }

	    //AssertD ( unHi == unLo-1, "mainQSort3(2)" );
         if (gtHi < ltLo) {
             //mpush(lo, hi, d+1 );
             stackLo[sp] = lo;
             stackHi[sp] = hi;
             stackD [sp] = d+1;
	     sp++;
             continue;
         }
         //n = mmin(ltLo-lo, unLo-ltLo); mvswap(lo, unLo-n, n);
         n = (ltLo -lo) < (unLo-ltLo)? (ltLo-lo): (unLo-ltLo);        
         int yyp1 = lo;
         int yyp2 = unLo-n;               
         int yyn  = n;               
         while (yyn > 0) {
             //mswap(ptr[yyp1], ptr[yyp2]);    
             //int zztmp = ptr.get(yyp1);
             //ptr.put(yyp1, ptr.get(yyp2));
             //ptr.put(yyp2, zztmp);
             //ptr.fswap(yyp1, yyp2);
             zz1 = yyp1 << 2;
             byte b1 = parray[zz1], b2 = parray[zz1+1], b3=parray[zz1+2], b4=parray[zz1+3];
             //zz2 *= 4;
             zz2 = yyp2 << 2;
             parray[zz1] = parray[zz2]; parray[zz1+1] = parray[zz2 + 1]; 
             parray[zz1+2] = parray[zz2 + 2]; parray[zz1+3] = parray[zz2+3];
             parray[zz2] = b1; parray[zz2+1] = b2; parray[zz2+2] = b3; parray[zz2+3] = b4;
             yyp1++; yyp2++; yyn--;          
         }
         //m = mmin(hi-gtHi, gtHi-unHi); mvswap(unLo, hi-m+1, m);
         m = (hi-gtHi)<(gtHi-unHi)?(hi-gtHi): (gtHi-unHi);
         yyp1 = unLo;
         yyp2 = hi-m+1;
         yyn = m;
         while (yyn > 0) {
             //mswap(ptr[yyp1], ptr[yyp2]);    
             //int zztmp = ptr.get(yyp1);
             //ptr.put(yyp1, ptr.get(yyp2));
             //ptr.put(yyp2, zztmp);
             //ptr.fswap(yyp1, yyp2);
             zz1 = yyp1 << 2;
             byte b1 = parray[zz1], b2 = parray[zz1+1], b3=parray[zz1+2], b4=parray[zz1+3];
             //zz2 *= 4;
             zz2 = yyp2 << 2;
             parray[zz1] = parray[zz2]; parray[zz1+1] = parray[zz2 + 1]; 
             parray[zz1+2] = parray[zz2 + 2]; parray[zz1+3] = parray[zz2+3];
             parray[zz2] = b1; parray[zz2+1] = b2; parray[zz2+2] = b3; parray[zz2+3] = b4;
             yyp1++; yyp2++; yyn--;          
         }
         n = lo + unLo - ltLo - 1;
         m = hi - (gtHi - unHi) + 1;

         nextLo[0] = lo;  nextHi[0] = n;   nextD[0] = d;
         nextLo[1] = m;   nextHi[1] = hi;  nextD[1] = d;
         nextLo[2] = n+1; nextHi[2] = m-1; nextD[2] = d+1;

         //mnextsize(int az, int[] nextHi, int[] nextLo){ return (nextHi[az]-nextLo[az]); }
         //if (mnextsize(0, nextHi, nextLo) < mnextsize(1, nextHi, nextLo)){
         if((nextHi[0] - nextLo[0]) < (nextHi[1] - nextLo[1])){
             //mnextswap(0,1);
             int az = 0; int bz = 1;
             int tz;                                                  
             tz = nextLo[az]; nextLo[az] = nextLo[bz]; nextLo[bz] = tz; 
             tz = nextHi[az]; nextHi[az] = nextHi[bz]; nextHi[bz] = tz; 
             tz = nextD [az]; nextD [az] = nextD [bz]; nextD [bz] = tz; 
         }
         //if (mnextsize(1, nextHi, nextLo) < mnextsize(2, nextHi, nextLo)){
         if((nextHi[1] - nextLo[1]) < (nextHi[2] - nextLo[2])){
             //mnextswap(1,2);
             int az = 1; int bz = 2;
             int tz;                                                  
             tz = nextLo[az]; nextLo[az] = nextLo[bz]; nextLo[bz] = tz; 
             tz = nextHi[az]; nextHi[az] = nextHi[bz]; nextHi[bz] = tz; 
             tz = nextD [az]; nextD [az] = nextD [bz]; nextD [bz] = tz; 
         }
         //if (mnextsize(0, nextHi, nextLo) < mnextsize(1, nextHi, nextLo)){
         if((nextHi[0] - nextLo[0]) < (nextHi[1] - nextLo[1])){
             //mnextswap(0,1);
             int az = 0; int bz = 1;
             int tz;                                                  
             tz = nextLo[az]; nextLo[az] = nextLo[bz]; nextLo[bz] = tz; 
             tz = nextHi[az]; nextHi[az] = nextHi[bz]; nextHi[bz] = tz; 
             tz = nextD [az]; nextD [az] = nextD [bz]; nextD [bz] = tz; 
         }

         //AssertD (mnextsize(0) >= mnextsize(1), "mainQSort3(8)" );
         //AssertD (mnextsize(1) >= mnextsize(2), "mainQSort3(9)" );

         //mpush (nextLo[0], nextHi[0], nextD[0]);
         stackLo[sp] = nextLo[0]; 
         stackHi[sp] = nextHi[0]; 
         stackD [sp] = nextD[0]; 
         sp++; 
         //mpush (nextLo[1], nextHi[1], nextD[1]);
         stackLo[sp] = nextLo[1]; 
         stackHi[sp] = nextHi[1]; 
         stackD [sp] = nextD[1]; 
         sp++; 
         //mpush (nextLo[2], nextHi[2], nextD[2]);
         stackLo[sp] = nextLo[2];
         stackHi[sp] = nextHi[2]; 
         stackD [sp] = nextD[2]; 
         sp++; 
       }

    }

    static int Js = 0;
    public static int SETMASK = (1 << 21);
    public static int CLEARMASK = (~(SETMASK));
    public static void mainSort (IntView ptr, 
                byte[]  block,
                ShortView quadrant, 
                IntView ftab,
                int   nblock,
                int   verb,
                int[]  budget ){

	//IntBuffer ptr = _ptr.asIntBuffer();
        //IntView ptr = new IntView(_ptr.array());
        //ShortBuffer quadrant = _quadrant.asShortBuffer();
        //IntBuffer ftab = _ftab.asIntBuffer();
         
       int  i, j, k, ss, sb;
       int[] runningOrder = new int[256];
       boolean[] bigDone = new boolean[256];
       int[] copyStart = new int[256];
       int[] copyEnd = new int[256];
       int  c1;
       int numQSorted;
       int s;
       //if (verb >= 4) VPrintf0 ( "        main sort initialise ...\n" );

       byte[] parray = ptr.b;
       byte[] farray = ftab.b; byte[] qarray = quadrant.b;
       int start = quadrant.start;//getStart();
       /*-- set up the 2-byte frequency table --*/
       //for (i = 65536; i >= 0; i--){
       for(i = 262144; i >= 0; i -= 4){
	   // ftab.put(i,0);
           farray[i] = 0;
           farray[i+1] = 0;
           farray[i+2] = 0;
           farray[i+3] = 0;           
       }

       int a1, a2, a3, a4;
       int _i;
       long _i2;
       j = (block[0] & 0xff) << 8;
       i = nblock-1;
       for (; i >= 3; i -= 4) {
           //quadrant.put(i, (short)0);
           _i = (i << 1) + start;
           qarray[_i++] = 0; qarray[_i] = 0;
           j = (j >> 8) | ((block[i] & 0xff) << 8);//( ((int)block[i]) << 8);

           //ftab[j]++;
           //ftab.put(j, ftab.get(j)+1);
           //_i = j << 2;
           a1 = j << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
	   _i2 = (((long)(farray[a1] & 0xff) << 24) | 
	         ((farray[a2] & 0xff)<<16)| 
	         ((farray[a3] & 0xff)<<8)|
	         (farray[a4] & 0xff))  + 1;
           farray[a1] = (byte)(_i2>>24);
           farray[a2] = (byte)(_i2>>16);
           farray[a3] = (byte)(_i2>>8);
           farray[a4] = (byte)_i2;    

           //quadrant.put(i -1, (short)0);//quadrant[i-1] = 0;
           _i = ((i-1) << 1) + start;
           qarray[_i++] = 0; qarray[_i] = 0;
           j = (j >> 8) | ((block[i-1] & 0xff) << 8);//( ((int)block[i-1]) << 8);

           //ftab[j]++;
           //ftab.put(j, ftab.get(j)+1);
           //_i = j << 2;
           a1 = j << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           _i2 = (((long)(farray[a1] & 0xff) << 24) | 
	         ((farray[a2] & 0xff)<<16)| 
	         ((farray[a3] & 0xff)<<8)|
	          (farray[a4] & 0xff))  + 1;
           farray[a1] = (byte)(_i2>>24);
           farray[a2] = (byte)(_i2>>16);
           farray[a3] = (byte)(_i2>>8);
           farray[a4] = (byte)_i2;  
  
           //quadrant[i-2] = 0;
           //quadrant.put(i -2, (short)0);
           _i = ((i-2) << 1) + start;
           qarray[_i++] = 0; qarray[_i] = 0;
           j = (j >> 8) | ((block[i-2] & 0xff) << 8);//( ((int)block[i-2]) << 8);

           //ftab[j]++;
           //ftab.put(j, ftab.get(j)+1);
           //_i = j << 2;
           a1 = j << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           _i2 = (((long)(farray[a1] & 0xff) << 24) | 
	         ((farray[a2] & 0xff)<<16)| 
	         ((farray[a3] & 0xff)<<8)|
	          (farray[a4] & 0xff))  + 1;
           farray[a1] = (byte)(_i2>>24);
           farray[a2] = (byte)(_i2>>16);
           farray[a3] = (byte)(_i2>>8);
           farray[a4] = (byte)_i2;    

           //quadrant[i-3] = 0;
           //quadrant.put(i-3, (short)0);
           _i = ((i-3) << 1) + start;
           qarray[_i++] = 0; qarray[_i] = 0;
           j = (j >> 8) | ((block[i-3] & 0xff) << 8);//( ((int)block[i-3]) << 8);

           //ftab[j]++;
           //ftab.put(j, ftab.get(j)+1);
           //_i = j << 2;
           a1 = j << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           _i2 = (((long)(farray[a1] & 0xff) << 24) | 
	                ((farray[a2] & 0xff)<<16)| 
	                ((farray[a3] & 0xff)<<8)|
	                 (farray[a4] & 0xff))  + 1;
           farray[a1] = (byte)(_i2>>24);
           farray[a2] = (byte)(_i2>>16);
           farray[a3] = (byte)(_i2>>8);
           farray[a4] = (byte)_i2;    
       }


       for (; i >= 0; i--) {
           //quadrant[i] = 0;
          //quadrant.put(i, (short)0);
          _i = (i << 1) + start;
          qarray[_i++] = 0; qarray[_i] = 0;
          j = (j >> 8) | ((block[i] & 0xff) << 8);//( ((int)block[i]) << 8);
          //ftab[j]++;
          //ftab.put(j, ftab.get(j)+1);
          //_i = j << 2;
          a1 = j << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
          _i2 = (((long)(farray[a1] & 0xff) << 24) | 
	         ((farray[a2] & 0xff)<<16)| 
	         ((farray[a3] & 0xff)<<8)|
	          (farray[a4] & 0xff))  + 1;
          farray[a1] = (byte)(_i2>>24);
          farray[a2] = (byte)(_i2>>16);
          farray[a3] = (byte)(_i2>>8);
          farray[a4] = (byte)_i2;
       }

       /*-- (emphasises close relationship of block & quadrant) --*/
       for (i = 0; i < BZ_N_OVERSHOOT; i++) {
           //block   [nblock+i] = block[i];
           block[nblock + i] = block[i];
           //quadrant[nblock+i] = 0;
           _i = ((nblock + i) << 1) + start;
           //quadrant.put(nblock + i, (short)0);
           qarray[_i++] = 0; qarray[_i] = 0;
       }

       //if (verb >= 4) VPrintf0 ( "        bucket sorting ...\n" );

       /*-- Complete the initial radix sort --*/
       //for (i = 1; i <= 65536; i++){
       for(i = 4, _i = 0; i <= 262144;){
           a1 = i++; a2 = i++; a3 = i++; a4 = i++;
           final long x = 
	        ((((long)(farray[a1] & 0xff) << 24) | 
                        ((farray[a2] & 0xff) << 16) | 
	                ((farray[a3] & 0xff) << 8) |
		         (farray[a4] & 0xff))
                    +
	        (((long)(farray[_i++] & 0xff) << 24) | 
	               ((farray[_i++] & 0xff) << 16) | 
	               ((farray[_i++] & 0xff) << 8) |
	                (farray[_i++] & 0xff))) & UINT32;
           farray[a1] = (byte)(x >> 24);
           farray[a2] = (byte)(x >> 16);
           farray[a3] = (byte)(x >> 8);
           farray[a4] = (byte)x;
       }

       s = (block[0] & 0xff) << 8;//block[0] << 8;
       i = nblock-1;
       for (; i >= 3; i -= 4) {
           s = (s >> 8) | ((block[i] & 0xff) << 8);//(block[i] << 8);
           //_i = s << 2;
           a1 = s << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           //j = ftab.get(s) - 1;//(int)ftab[s] -1;
	   j = (int)((((long)(farray[a1] & 0xff) << 24) | 
	       ((farray[a2] & 0xff)<<16)| 
	       ((farray[a3] & 0xff)<<8)|
		      (farray[a4] & 0xff)) -1);
           //ftab[s] = j;
           //ftab.put(s, j);
           farray[a1] = (byte)(j>>24);
           farray[a2] = (byte)(j>>16);
           farray[a3] = (byte)(j>>8);
           farray[a4] = (byte)j;
       
           //ptr[j] = i;
           //ptr.put(j, i);
           _i = j << 2;
           parray[_i++] = (byte)(i>>24);
           parray[_i++] = (byte)(i>>16);
           parray[_i++] = (byte)(i>>8);
           parray[_i] = (byte)i;

           s = (s >> 8) | ((block[i-1] & 0xff) <<8);//(block[i-1] << 8);

           //_i = s << 2;
           a1 = s << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           //j = ftab.get(s) -1;//(int)ftab[s] -1;
           j = (int)((((long)(farray[a1] & 0xff) << 24) | 
	                    ((farray[a2] & 0xff)<<16)| 
	                    ((farray[a3] & 0xff)<<8)|
		             (farray[a4] & 0xff)) -1);
           //ftab[s] = j;
           //ftab.put(s, j);       
           farray[a1] = (byte)(j>>24);
           farray[a2] = (byte)(j>>16);
           farray[a3] = (byte)(j>>8);
           farray[a4] = (byte)j; 

           //ptr[j] = i-1;
           //ptr.put(j, i-1);
           _i = j << 2;
           _i2 = i -1;
           parray[_i++] = (byte)((_i2)>>24);
           parray[_i++] = (byte)((_i2)>>16);
           parray[_i++] = (byte)((_i2)>>8);
           parray[_i] = (byte)(_i2);

           s = (s >> 8) | ((block[i-2] & 0xff) << 8);//(block[i-2] << 8);
           //j = ftab.get(s) - 1;//(int)ftab[s] -1;
           //_i = s << 2;
           a1 = s << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           j = (int)((((long)(farray[a1] & 0xff) << 24) | 
	       ((farray[a2] & 0xff)<<16)| 
	       ((farray[a3] & 0xff)<<8)|
		      (farray[a4] & 0xff)) -1);
           //ftab[s] = j;
           //ftab.put(s, j);
           farray[a1] = (byte)(j>>24);
           farray[a2] = (byte)(j>>16);
           farray[a3] = (byte)(j>>8);
           farray[a4] = (byte)j;

           //ptr[j] = i-2;
           //ptr.put(j, i-2);
           _i = j << 2;
           _i2 = i - 2;
           parray[_i++] = (byte)((_i2)>>24);
           parray[_i++] = (byte)((_i2)>>16);
           parray[_i++] = (byte)((_i2)>>8);
           parray[_i] = (byte)(_i2);

           s = (s >> 8) | ((block[i-3] & 0xff) << 8);//(block[i-3] << 8);
           //j = ftab.get(s) -1;//(int)ftab[s] -1;
           //_i = s << 2;
           a1 = s << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
           j = (int)((((long)(farray[a1] & 0xff) << 24) | 
	                    ((farray[a2] & 0xff)<<16)| 
	                    ((farray[a3] & 0xff)<<8)|
		             (farray[a4] & 0xff)) -1);
           //ftab[s] = j;
           //ftab.put(s, j);
           farray[a1] = (byte)(j>>24);
           farray[a2] = (byte)(j>>16);
           farray[a3] = (byte)(j>>8);
           farray[a4] = (byte)j; 

           //ptr[j] = i-3;
           //ptr.put(j, i -3);
           _i = j << 2;
           _i2 = i - 3;
           parray[_i++] = (byte)((_i2)>>24);
           parray[_i++] = (byte)((_i2)>>16);
           parray[_i++] = (byte)((_i2)>>8);
           parray[_i] = (byte)(_i2);
       }

       for (; i >= 0; i--) {
           s = (s >> 8) | ((block[i] & 0xff)<<8);//(block[i] << 8);
          //j = ftab.get(s) - 1; //(int)((ftab[s] -1);
          //_i = s << 2;
          a1 = s << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
          j = (int)((((long)(farray[a1] & 0xff) << 24) | 
	       ((farray[a2] & 0xff)<<16)| 
	       ((farray[a3] & 0xff)<<8)|
		     (farray[a4] & 0xff)) -1);
           //ftab[s] = j;
           //ftab.put(s, j);
           farray[a1] = (byte)(j>>24);
           farray[a2] = (byte)(j>>16);
           farray[a3] = (byte)(j>>8);
           farray[a4] = (byte)j; 

           //ptr[j] = i;
           //ptr.put(j, i);
           _i = j << 2;
           parray[_i++] = (byte)(i>>24);
           parray[_i++] = (byte)(i>>16);
           parray[_i++] = (byte)(i>>8);
           parray[_i] = (byte)i;
       }

       /**--
          Now ftab contains the first loc of every small bucket.
          Calculate the running order, from smallest to largest
          big bucket.
       --*/
       for (i = 0; i <= 255; i++) {
          bigDone     [i] = false;
          runningOrder[i] = i;
       }

       {
          int vv;
          int h = 1;
          do{ h = 3 * h + 1; } while (h <= 256);
          do {
             h = h / 3;
             for (i = h; i <= 255; i++) {
                vv = runningOrder[i];
                j = i;
	       //zero:
               //while ( BIGFREQ(runningOrder[j-h]) > BIGFREQ(vv) ) {
               int ro1 = ((runningOrder[j-h]+1) << 8) << 2;
               int ro2 = ((runningOrder[j-h]) << 8) << 2;
               int vv1 = (((vv)+1)<<8) << 2;
               int vv2 = ((vv)<<8) << 2;
               //while( (ftab.get(((runningOrder[j-h])+1) << 8) - ftab.get((runningOrder[j-h]) << 8)) >
	       //   (ftab.get(((vv)+1) << 8) - ftab.get((vv) << 8)) ){
	       zero:
               while( ((((long)(farray[ro1] & 0xff) << 24) | ((farray[ro1 + 1] & 0xff)<<16)| 
		    ((farray[ro1 + 2] & 0xff)<<8)| (farray[ro1 + 3] & 0xff))
                                     -
                   (((farray[ro2] & 0xff) << 24) | ((farray[ro2 + 1] & 0xff)<<16)| 
		    ((farray[ro2 + 2] & 0xff)<<8)| (farray[ro2 + 3] & 0xff)))
                                       >
		      ((((long)(farray[vv1] & 0xff) << 24) | ((farray[vv1 + 1] & 0xff)<<16)| 
		    ((farray[vv1 + 2] & 0xff)<<8)| (farray[vv1 + 3] & 0xff))
                                     -
                   (((farray[vv2] & 0xff) << 24) | ((farray[vv2 + 1] & 0xff)<<16)| 
		    ((farray[vv2 + 2] & 0xff)<<8)| (farray[vv2 + 3] & 0xff))) ){
                     runningOrder[j] = runningOrder[j-h];
                     j = j - h;
                     if (j <= (h - 1)) break zero;//goto zero;
                     ro1 = ((runningOrder[j-h]+1) << 8) << 2;
                     ro2 = ((runningOrder[j-h]) << 8) << 2;
                     //vv1 = (((vv)+1)<<8) << 2;
                     //vv2 = ((vv)<<8) << 2;
                }
                //zero:
                runningOrder[j] = vv;
             }
          } while (h != 1);
       }

       /*--
          The main sorting loop.
       --*/

       numQSorted = 0;

       for (i = 0; i <= 255; i++) {

          /*--
             Process big buckets, starting with the least full.
             Basically this is a 3-step process in which we call
             mainQSort3 to sort the small buckets [ss, j], but
             also make a big effort to avoid the calls if we can.
          --*/
          ss = runningOrder[i];

          /*--
             Step 1:
             Complete the big bucket [ss] by quicksorting
             any unsorted small buckets [ss, j], for j != ss.  
             Hopefully previous pointer-scanning phases have already
             completed many of the small buckets [ss, j], so
             we don't have to sort them at all.
          --*/
          int _sb;
          for (j = 0; j <= 255; j++) {
             if (j != ss) {
                sb = (ss << 8) + j;
                //_sb = sb << 2;
                a1 = sb << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
            //if ((ftab.get(sb) & SETMASK) == 0 ) {
	        if(((((long)(farray[a1] & 0xff) << 24) | ((farray[a2] & 0xff)<<16)| 
		     ((farray[a3] & 0xff)<<8)|(farray[a4] & 0xff)) & SETMASK) == 0){
		    //int lo = ftab.get(sb)   & CLEARMASK;
                    int lo = (int)((((long)(farray[a1] & 0xff) << 24) | ((farray[a2] & 0xff)<<16)| 
				    ((farray[a3] & 0xff)<<8)|(farray[a4] & 0xff)) & CLEARMASK);
		    //int hi = (ftab.get(sb+1) & CLEARMASK) - 1;
                    //_sb += 4;
                    a1 += 4; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
		    int hi = (int)(((((long)(farray[a1] & 0xff) << 24) | ((farray[a2] & 0xff)<<16)| 
				     ((farray[a3] & 0xff)<<8)|(farray[a4] & 0xff)) & CLEARMASK) -1);
                    if (hi > lo) {
		       //if (verb >= 4)
		       //VPrintf4 ( "        qsort [0x%x, 0x%x]   "
		       //           "done %d   this %d\n",
		       //           ss, j, numQSorted, hi - lo + 1 );
                       mainQSort3 ( 
                           ptr, block, quadrant, nblock, 
                           lo, hi, BZ_N_RADIX, budget 
                       );   
                      numQSorted += (hi - lo + 1);
                      if (budget[0] < 0){
                          return;
                      }
                   }
                }
                //ftab[sb] |= SETMASK;
                //_sb = sb << 2;
                a1 = sb << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
                _i = (int)((((long)(farray[a1] & 0xff) << 24) | ((farray[a2] & 0xff)<<16)| 
			    ((farray[a3] & 0xff)<<8)|(farray[a4] & 0xff)) | SETMASK);
                farray[a1] = (byte)(_i>>24);
                farray[a2] = (byte)(_i>>16);
                farray[a3] = (byte)(_i>>8);
                farray[a4] = (byte)_i; 
                //ftab.put(sb, ftab.get(sb) | SETMASK);
             }
          }

          //AssertH ( !bigDone[ss], 1006 );

          /*--
             Step 2:
             Now scan this big bucket [ss] so as to synthesise the
             sorted order for small buckets [t, ss] for all t,
             including, magically, the bucket [ss,ss] too.
             This will avoid doing Real Work in subsequent Step 1's.
          --*/
          {
              for (j = 0; j <= 255; j++) {
	         //_sb = ((j << 8) + ss) << 2;
                 a1 = ((j << 8) + ss) << 2;
                 _i = (int)((((long)(farray[a1] & 0xff) << 24) | ((farray[a1 + 1] & 0xff)<<16)| 
			     ((farray[a1 + 2] & 0xff)<<8)|(farray[a1 + 3] & 0xff)) & CLEARMASK);
	         //copyStart[j] = (int)ftab.get((j << 8) + ss)     & CLEARMASK;
                 copyStart[j] = _i;
                 a1 = ((j << 8) + ss + 1) << 2;
	         _i = (int)((((((long)farray[a1] & 0xff) << 24) | ((farray[a1 + 1] & 0xff)<<16)| 
			      ((farray[a1 + 2] & 0xff)<<8)|(farray[a1 + 3] & 0xff)) & CLEARMASK) - 1);
                copyEnd[j] = _i;
	        //copyEnd  [j] = (int)(ftab.get((j << 8) + ss + 1) & CLEARMASK) - 1;
             }

             _sb = (ss << 8) <<2;
             j = (int)((((long)(farray[_sb] & 0xff) << 24) | ((farray[_sb + 1] & 0xff)<<16)| 
			((farray[_sb + 2] & 0xff)<<8)|(farray[_sb + 3] & 0xff)) & CLEARMASK);
             //for (j = (int)ftab.get(ss << 8) & CLEARMASK; j < copyStart[ss]; j++) {
             for(; j < copyStart[ss]; j++){
                 _sb = j << 2;
	         //k = (int)ptr.get(j)-1; 
                 k = (int)((((long)(parray[_sb] & 0xff) << 24) | ((parray[_sb + 1] & 0xff)<<16)| 
			    ((parray[_sb + 2] & 0xff)<<8)|(parray[_sb + 3] & 0xff)) -1);
                 if (k < 0) k += nblock;
	         c1 = block[k] & 0xff;
	         if (!bigDone[c1]){
		     _i = (copyStart[c1]++) << 2;
                     parray[_i++] = (byte)(k>>24);
                     parray[_i++] = (byte)(k>>16);
                     parray[_i++] = (byte)(k>>8);
                     parray[_i] = (byte)k;
		     //ptr.put(copyStart[c1]++ ,k);
                 }
             }

             _sb = (ss + 1 << 8) <<2;
             j = (int)(((((long)(farray[_sb] & 0xff) << 24) | ((farray[_sb + 1] & 0xff)<<16)| 
			 ((farray[_sb + 2] & 0xff)<<8)|(farray[_sb + 3] & 0xff)) & CLEARMASK) -1);
            //for (j = (int)(ftab.get((ss+1) << 8) & CLEARMASK) - 1; j > copyEnd[ss]; j--) {
            for(;j > copyEnd[ss]; j--){
                 _sb = j << 2;
	         //k = (int)ptr.get(j)-1; 
                 k = (int)(((((long)parray[_sb] & 0xff) << 24) | ((parray[_sb + 1] & 0xff)<<16)| 
			    ((parray[_sb + 2] & 0xff)<<8)|(parray[_sb + 3] & 0xff)) -1);
	         //k = (int)ptr.get(j)-1; 
                 if (k < 0) k += nblock;
	         c1 = block[k] & 0xff;
	         if (!bigDone[c1]) {
		     _i = (copyEnd[c1]--) << 2;
                     parray[_i] = (byte)(k>>24);
                     parray[_i+1] = (byte)(k>>16);
                     parray[_i+2] = (byte)(k>>8);
                     parray[_i+3] = (byte)k;
		     //ptr.put(copyEnd[c1]--, k);
                 }
             }
          }


          //AssertH ( (copyStart[ss]-1 == copyEnd[ss])
          //        || 
                /* Extremely rare case missing in bzip2-1.0.0 and 1.0.1.
                   Necessity for this case is demonstrated by compressing 
                   a sequence of approximately 48.5 million of character 
                   251; 1.0.0/1.0.1 will then die here. */
         //        (copyStart[ss] == 0 && copyEnd[ss] == nblock-1),
        //        1007 )

         for (j = 0; j <= 255; j++){ //ftab[(j << 8) + ss] |= SETMASK;
             //int fi = (j<< 8) + ss;
             //ftab.put(fi, ftab.get(fi) | SETMASK);
             //_sb = sb << 2;
	     //_sb = ((j<<8)+ss) << 2;
             a1 = ((j<<8)+ss) << 2; a2 = a1 + 1; a3 = a1 + 2; a4 = a1 + 3;
             _i2 = (((long)(farray[a1] & 0xff) << 24) | ((farray[a2] & 0xff)<<16)| 
		   ((farray[a3] & 0xff)<<8)|(farray[a4] & 0xff)) | SETMASK;
             farray[a1] = (byte)(_i2>>24);
             farray[a2] = (byte)(_i2>>16);
             farray[a3] = (byte)(_i2>>8);
             farray[a4] = (byte)_i2; 
         }


         /*--
            Step 3:
            The [ss] big bucket is now done.  Record this fact,
            and update the quadrant descriptors.  Remember to
            update quadrants in the overshoot area too, if
            necessary.  The "if (i < 255)" test merely skips
            this updating for the last bucket processed, since
            updating for the last bucket is pointless.

            The quadrant array provides a way to incrementally
            cache sort orderings, as they appear, so as to 
            make subsequent comparisons in fullGtU() complete
            faster.  For repetitive blocks this makes a big
            difference (but not big enough to be able to avoid
            the fallback sorting mechanism, exponential radix sort).

            The precise meaning is: at all times:

               for 0 <= i < nblock and 0 <= j <= nblock

               if block[i] != block[j], 

                  then the relative values of quadrant[i] and 
                       quadrant[j] are meaningless.

                  else {
                     if quadrant[i] < quadrant[j]
                        then the string starting at i lexicographically
                        precedes the string starting at j

                     else if quadrant[i] > quadrant[j]
                        then the string starting at j lexicographically
                        precedes the string starting at i

                     else
                        the relative ordering of the strings starting
                        at i and j has not yet been determined.
                  }
         --*/
         bigDone[ss] = true;
 
         if (i < 255) {
	     //int bbStart  = (int)ftab.get(ss << 8) & CLEARMASK;
	     _sb = (ss << 8) << 2;
             int bbStart = (int)((((long)(farray[_sb] & 0xff) << 24) | ((farray[_sb + 1] & 0xff)<<16)| 
				  ((farray[_sb + 2] & 0xff)<<8)|(farray[_sb + 3] & 0xff)) & CLEARMASK);
	     //int bbSize   = (int)(ftab.get((ss+1) << 8) & CLEARMASK) - bbStart;
             _sb = ((ss+1) << 8) << 2;
             int bbSize = (int)(((((long)(farray[_sb] & 0xff) << 24) | ((farray[_sb + 1] & 0xff)<<16)| 
				  ((farray[_sb + 2] & 0xff)<<8)|(farray[_sb + 3] & 0xff)) & CLEARMASK) - bbStart);
             int shifts   = 0;

             while ((bbSize >> shifts) > 65534) shifts++;

             for (j = bbSize-1; j >= 0; j--) {
                 _sb = (bbStart + j) << 2;
	         //int a2update     = (int)ptr.get(bbStart + j);
                 int a2update = (((parray[_sb] & 0xff) << 24) | ((parray[_sb + 1] & 0xff)<<16)| 
			         ((parray[_sb + 2] & 0xff)<<8)|(parray[_sb + 3] & 0xff));
                 short qVal        = (short)((j >> shifts));
                 //quadrant.put(a2update ,qVal);
                 _sb = (a2update << 1) + start;
                 qarray[_sb++] = (byte)(qVal >> 8);
                 qarray[_sb] = (byte)qVal;
                 if (a2update < BZ_N_OVERSHOOT){
                     _sb = ((a2update + nblock) << 1) + start;
                     qarray[_sb++] = (byte)(qVal >> 8);
                     qarray[_sb] = (byte)qVal;
		     //quadrant.put(a2update + nblock, qVal);
                 }
             }
             //AssertH ( ((bbSize-1) >> shifts) <= 65535, 1002 );
          }
  
       }


       //if (verb >= 4)
       // VPrintf3 ( "        %d pointers, %d sorted, %d scanned\n",
       //            nblock, numQSorted, nblock - numQSorted );
    }

   

   public static void BZ2_blockSort (EState s){
       byte[] block = s.block;
       int  nblock = s.nblock;
       int verb   = s.verbosity;
       int   wfact  = s.workFactor;
       ShortView quadrant;
       int   budget;
       int   budgetInit;
       int   i;

       IntView ptr = s.ptr; IntView arr1 = s.arr1; IntView arr2 = s.arr2;
       IntView ftab = s.ftab;


       if (nblock < 10000) {
          fallbackSort ( arr1, arr2, ftab, nblock, verb );
       } else {
          /* Calculate the location for quadrant, remembering to get
             the alignment right.  Assumes that &(block[0]) is at least
             2-byte aligned -- this should be ok since block is really
             the first section of arr2.
          */
          i = nblock+BZ_N_OVERSHOOT;
          if ((i & 1) != 0) i++;
          quadrant = new ShortViewSlice(block, i);
          //quadrant = //(UInt16*)(&(block[i]));

          /* (wfact-1) / 3 puts the default-factor-30
             transition point at very roughly the same place as 
             with v0.1 and v0.9.0.  
             Not that it particularly matters any more, since the
             resulting compressed stream is now the same regardless
             of whether or not we use the main sort or fallback sort.
          */
          if (wfact < 1  ) wfact = 1;
          if (wfact > 100) wfact = 100;
          budgetInit = nblock * ((wfact-1) / 3);
          budget = budgetInit;
          int b_array[] = { budget};
          mainSort (ptr, block, quadrant, ftab, nblock, verb, b_array );
          budget = b_array[0];
          if (verb >= 3);
	      //VPrintf3 ( "      %d work, %d block, ratio %5.2f\n",
	      //        budgetInit - budget,
	      //        nblock, 
	      //        (float)(budgetInit - budget) /
	      //        (float)(nblock==0 ? 1 : nblock) ); 
          if (budget < 0) {
	      //   if (verb >= 2) 
	      //  VPrintf0 ( "    too repetitive; using fallback"
	      //        " sorting algorithm\n" );
             fallbackSort (arr1, arr2, ftab, nblock, verb );
          }
       }

       s.origPtr = -1;
       for (i = 0; i < s.nblock; i++)
           if (ptr.get(i) == 0)
             { s.origPtr = i; break; };

       ///AssertH( s->origPtr != -1, 1003 );
   }
}